<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.9.1 of 2012年10月18日 on 2013年2月6日 at 16:03:00</time-stamp>


<class>
<name>Kime</name>
<environment>KSU</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>KSU-Example</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>KSU.Kime class</class-id> <category>examples</category>

<body package="KSU-Example" selector="example0">example0
	"KSU.Kime example0."

	JunURL requestInternetConnection</body>

<body package="KSU-Example" selector="example1">example1
	"KSU.Kime example1."

	| aFilename aDirectory |
	aFilename := 'Foo-Texture.st' asFilename.
	aDirectory := JunSystem fileInDirectoryFor: aFilename.
	aDirectory ifNil: [^nil].
	aFilename := aDirectory construct: aFilename asString.
	aFilename exists ifFalse: [^nil].
	aFilename fileIn</body>

<body package="KSU-Example" selector="example2">example2
	"KSU.Kime example2."

	FooTexture showCheckeredImage</body>

<body package="KSU-Example" selector="example3">example3
	"KSU.Kime example3."

	FooTexture showLatticedImage</body>

<body package="KSU-Example" selector="example4">example4
	"KSU.Kime example4."

	| aTexture aPolygon |
	aTexture := JunOpenGLTexture image: FooTexture checkeredImage.
	aTexture coordinates: (Array
				with: 0 , 0
				with: 1 , 0
				with: 1 , 1
				with: 0 , 1).
	aPolygon := JunOpenGL3dPolygon
				with: -1 , -1 , 0
				with: 1 , -1 , 0
				with: 1 , 1 , 0
				with: -1 , 1 , 0.
	aPolygon paint: ColorValue white.
	aPolygon texture: aTexture.
	^aPolygon</body>

<body package="KSU-Example" selector="example5">example5
	"KSU.Kime example5."

	FooTexture showCheckeredPolygon yourself</body>

<body package="KSU-Example" selector="example6">example6
	"KSU.Kime example6."

	FooTexture showLatticedPolygon yourself</body>

<body package="KSU-Example" selector="example7">example7
	"KSU.Kime example7."

	FooTexture showCheckeredPolygon zoomHeight: 0.5</body>

<body package="KSU-Example" selector="example8">example8
	"KSU.Kime example8."

	FooTexture showLatticedPolygon zoomHeight: 0.5</body>

<body package="KSU-Example" selector="example9">example9
	"KSU.Kime example9."

	(FooTexture showCheckeredPolygon)
		zoomHeight: 2.3;
		grab: 0.7 , 0</body>

<body package="KSU-Example" selector="exampleA">exampleA
	"KSU.Kime exampleA."

	(FooTexture showLatticedPolygon)
		zoomHeight: 2.3;
		grab: -0.7 , 0</body>

<body package="KSU-Example" selector="exampleB">exampleB
	"KSU.Kime exampleB."

	| aCube stereoViewer |
	aCube := JunOpenGL3dObject cube.
	aCube paint: ColorValue gray.
	stereoViewer := JunOpenGLStereoDisplayModel new.
	stereoViewer displayObject: aCube.
	stereoViewer
		open;
		parallelProjection;
		wireframePresentation;
		crossing: true.
	^stereoViewer</body>

<body package="KSU-Example" selector="exampleC">exampleC
	"KSU.Kime exampleC."

	| aPolygon aTable aViewfinder aLight |
	aPolygon := FooTexture checkeredPolygon.
	aTable := Dictionary new.
	aTable add: #eyePoint -&gt; (0 , 1.3 , 0.13).
	aTable add: #projection -&gt; #perspectiveProjection.
	aTable add: #sightPoint -&gt; (0 , 0.7 , 0.07).
	aTable add: #upVector -&gt; (0 , 0 , 1).
	aTable add: #zoomHeight -&gt; 0.35.
	aViewfinder := JunOpenGLDisplayModel new.
	aViewfinder displayObject: aPolygon.
	aViewfinder defaultProjectionTable: aTable.
	aViewfinder openIn: ((16 , 9) * 50) alignedRectangleWithScreenCenter.
	(aLight := aViewfinder displayLights last) lightColor
		color: (ColorValue brightness: 0.8).
	aLight lightColorChanged.
	100 timesRepeat: 
			[aViewfinder do: [aViewfinder dolly: 0.0175] forMilliseconds: 100]</body>

<body package="KSU-Example" selector="exampleD">exampleD
	"KSU.Kime exampleD."

	FooTexture transformCheckeredTexture</body>

<body package="KSU-Example" selector="exampleE">exampleE
	"KSU.Kime exampleE."

	FooTexture transformLatticedTexture</body>

<body package="KSU-Example" selector="exampleF">exampleF
	"KSU.Kime exampleF."

	| cartoonMovie tickTime filmImages screenBoundingBox filmExtent aValue aPoint |
	cartoonMovie := JunCartoonMovie new.
	tickTime := 125.	"8Hz"
	filmImages := OrderedCollection new: FooTexture howManyFrames.
	screenBoundingBox := JunSystem screenBoundingBox.
	filmExtent := FooTexture filmExtent.
	aValue := (screenBoundingBox extent - filmExtent)
				/ (FooTexture howManyFrames - 1).
	aPoint := screenBoundingBox origin.
	FooTexture howManyFrames timesRepeat: 
			[| aBox anImage |
			aBox := (aPoint extent: filmExtent) rounded.
			aBox := aBox intersect: screenBoundingBox.
			anImage := JunImageUtility fromDisplay: aBox.
			filmImages add: anImage.
			aPoint := aPoint + aValue].
	filmImages
		do: [:anImage | cartoonMovie addImage: anImage keepTime: tickTime].
	cartoonMovie
		loop;
		openLightWeightWindowSpec;
		start.
	^cartoonMovie</body>

<body package="KSU-Example" selector="exampleG">exampleG
	"KSU.Kime exampleG."

	FooTexture showFilmImages</body>

<body package="KSU-Example" selector="exampleH">exampleH
	"KSU.Kime exampleH."

	FooTexture showFilmBody yourself</body>

<body package="KSU-Example" selector="exampleI">exampleI
	"KSU.Kime exampleI."

	FooTexture showFilmBody zoomHeight: 15</body>

<body package="KSU-Example" selector="exampleJ">exampleJ
	"KSU.Kime exampleJ."

	| aBody aViewfinder aLight aBlock |
	aBody := FooTexture filmBody.
	aViewfinder := aBody showIn: (500 , 500) alignedRectangleWithScreenCenter.
	(aLight := aViewfinder displayLights first) beOff.
	aLight lightStateChanged.
	(aLight := aViewfinder displayLights last) lightColor
		color: (ColorValue brightness: 0.8).
	aLight lightColorChanged.
	aBlock :=
			[:aPolygon |
			| centerPoint normalVector projectionTable |
			centerPoint := ((aPolygon vertexes at: 1) to: (aPolygon vertexes at: 3))
						center.
			normalVector := ((aPolygon vertexes at: 1)
						plane: (aPolygon vertexes at: 2)
						and: (aPolygon vertexes at: 3)) normalUnitVector.
			projectionTable := Dictionary new.
			projectionTable add: #sightPoint -&gt; centerPoint.
			projectionTable
				add: #eyePoint -&gt; ((centerPoint to: centerPoint + normalVector) atT: 3).
			projectionTable add: #upVector -&gt; (0 , 0 , 1).
			projectionTable add: #zoomHeight -&gt; 6.
			projectionTable yourself].
	aViewfinder defaultProjectionTable: (aBlock value: aBody components first).
	aViewfinder projectionTable: (aBlock value: aBody components first).
	aBody components , aBody components reverse do: 
			[:aPolygon |
			aViewfinder do: [aViewfinder projectionTable: (aBlock value: aPolygon)]
				forMilliseconds: 200].
	^aViewfinder</body>

<body package="KSU-Example" selector="exampleK">exampleK
	"KSU.Kime exampleK."

	FooTexture playFilmBody</body>

<body package="KSU-Example" selector="exampleL">exampleL
	"KSU.Kime exampleL."

	FooTexture showObjectFromZ</body>

<body package="KSU-Example" selector="exampleM">exampleM
	"KSU.Kime exampleM."

	FooTexture showObject</body>

<body package="KSU-Example" selector="exampleN">exampleN
	"KSU.Kime exampleN."

	FooTexture showObjectFromX</body>

<body package="KSU-Example" selector="exampleO">exampleO
	"KSU.Kime exampleO."

	FooTexture showObjectFromY</body>

<body package="KSU-Example" selector="exampleP">exampleP
	"KSU.Kime exampleP."

	FooTexture showObjectWithMovementVector</body>

<body package="KSU-Example" selector="exampleQ">exampleQ
	"KSU.Kime exampleQ."

	FooTexture showDice</body>

<body package="KSU-Example" selector="exampleR">exampleR
	"KSU.Kime exampleR."

	FooTexture showSaikoroExcept236</body>

<body package="KSU-Example" selector="exampleS">exampleS
	"KSU.Kime exampleS."</body>

<body package="KSU-Example" selector="exampleT">exampleT
	"KSU.Kime exampleT."</body>

<body package="KSU-Example" selector="exampleU">exampleU
	"KSU.Kime exampleU."</body>

<body package="KSU-Example" selector="exampleV">exampleV
	"KSU.Kime exampleV."</body>

<body package="KSU-Example" selector="exampleW">exampleW
	"KSU.Kime exampleW."</body>

<body package="KSU-Example" selector="exampleX">exampleX
	"KSU.Kime exampleX."</body>

<body package="KSU-Example" selector="exampleY">exampleY
	"KSU.Kime exampleY."</body>

<body package="KSU-Example" selector="exampleZ">exampleZ
	"KSU.Kime exampleZ."</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>KSU.Kime</class-id>
<body>Copyright 2008-2012 KSU (Kyoto Sangyo University). All Right Reserved.</body>
</comment>

</st-source>
